package phoneList.presentation;

import com.lutris.appserver.server.httpPresentation.*;

import phoneList.business.PhoneList;

public class DoActionPresentation implements HttpPresentation {

    public void run(HttpPresentationComms comms) throws Exception {
        String first = null;
        try {
            first = comms.request.getParameter("first");
        } catch (Exception e) {
        }
        String last = null;
        try {
            last = comms.request.getParameter("last");
        } catch (Exception e) {
        }
        String phone = null;
        try {
            phone = comms.request.getParameter("phone");
        } catch (Exception e) {
        }
        String id = null;
        try {
            id = comms.request.getParameter("id");
        } catch (Exception e) {
        }
        String action = null;
        try {
            action = comms.request.getParameter("action");
        } catch (Exception e) {
        }
        String okTarget = comms.request.getAppFileURIPath("ListPresentation.po");
        String errTarget = comms.request.getAppFileURIPath("ErrorPresentation.po");
        ClientPageRedirectException err =
                                    new ClientPageRedirectException(errTarget);
        if (action.equals("delete")) {
            if ((id == null) || (id.length() == 0)) {
                err.addArgument("err", "Error: no id specified.");
                throw err;
            }
            PhoneList.deletePerson(id);
        } else if (action.equals("edit")) {
            if ((id == null) || (id.length() == 0)) {
                err.addArgument("err", "Error: no id specified.");
                throw err;
            }
            if ((first == null) || (first.length() == 0)) {
                err.addArgument("err", "Error: no first name specified.");
                throw err;
            }
            if ((last == null) || (last.length() == 0)) {
                err.addArgument("err", "Error: no last name specified.");
                throw err;
            }
            if ((phone == null) || (phone.length() == 0)) {
                err.addArgument("err", "Error: no phone number specified.");
                throw err;
            }
            PhoneList.modifyPerson(id, first, last, phone);
        } else if (action.equals("create")) {
            if ((first == null) || (first.length() == 0)) {
                err.addArgument("err", "Error: no first name specified.");
                throw err;
            }
            if ((last == null) || (last.length() == 0)) {
                err.addArgument("err", "Error: no last name specified.");
                throw err;
            }
            if ((phone == null) || (phone.length() == 0)) {
                err.addArgument("err", "Error: no phone number specified.");
                throw err;
            }
            PhoneList.addPerson(first, last, phone);
        } else {
            // Shouldn't happen.
        }
        throw new ClientPageRedirectException(okTarget);
    }

}

