package phoneList.presentation;

// Standard imports
import java.io.IOException;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.appserver.server.httpPresentation.ClientPageRedirectException;
import org.w3c.dom.html.HTMLInputElement;

import phoneList.business.Person;
import phoneList.business.PhoneList;

public class EditPresentation implements HttpPresentation {

  private static EditHTML edit;

  public void run(HttpPresentationComms comms) throws HttpPresentationException, IOException {
    try{
      lookupPerson(comms);
    }catch(Exception e){
      e.printStackTrace();
    }
  }

  public static void lookupPerson(HttpPresentationComms comms) throws Exception {
      String id = comms.request.getParameter("id");
      Person p = null;
      if (id != null)
          p = PhoneList.getById(id);
      if (p == null) {
          String err = comms.request.getAppFileURIPath("ErrorPresentation.po");
          ClientPageRedirectException e = new ClientPageRedirectException(err);
          e.addArgument("err", "Internal error: id not found.");
          throw e;
      }
      edit = (EditHTML)comms.xmlcFactory.create(EditHTML.class);

      HTMLInputElement idHidden = edit.getElementId();
      idHidden.setValue(id);

      HTMLInputElement first = edit.getElementFirst_text();
      first.setValue(p.getFirstName());

      HTMLInputElement last = edit.getElementLast_text();
      last.setValue(p.getLastName());

      HTMLInputElement phone = edit.getElementPhone_text();
      phone.setValue(p.getPhoneNumber());

      edit.setTitle("Editing ");
      edit.setTextFirst(p.getFirstName());
      edit.setTextLast(p.getLastName());
      comms.response.writeDOM(edit);

  }

    private static void sendErrPage(HttpPresentationComms comms, String msg) throws Exception {
      comms.response.writeHTML("<HTML><HEAD><TITLE>ERROR</TITLE></HEAD><BODY>");
      comms.response.writeHTML("<h1>" + msg + "</h1><p>");
      comms.response.writeHTML("<a href=ListPresentation.po>Return</a>");
      comms.response.writeHTML("</BODY></HTML>");
  }
}



