#!/bin/sh

message() {
    if test ! -z $2 ; then
	echo Error: $1
	exit $2
    fi
    echo Info: $1
}

cd $(dirname $0)/..
WORK_DIR=$(pwd)
OUTPUT=$1
OUTPUT=${OUTPUT:=testwebapps}
cd $WORK_DIR
mkdir -p $OUTPUT
if test ! -w $OUTPUT ; then
    message "Cannot write into $OUTPUT"
fi
if test -d dist/../$OUTPUT ; then
    OUTPUT=$WORK_DIR/$OUTPUT
fi

if test $(basename $OUTPUT)X = autoloadX ; then
    SUFFIX=../jonas
fi
WEBAPPS_EXP=$2
WEBAPPS_EXP=${WEBAPPS_EXP:=${OUTPUT}/${SUFFIX}}

for warname in wars_jars_included/*.war; do
    cp $warname $OUTPUT
    warname=${warname/#webapps/}
    warname=${warname/%.war/}
    if test ! -d $WORK_DIR/dist/$warname; then
	message "$WORK_DIR/webapps/$warname.war doesn't change"
    else
	FILELIST=
	for filein in $WORK_DIR/dist/$warname/*.in; do
	    fileout=${filein//%.in/}
	    sed "s|@WEBAPPS@|${WEBAPPS_EXP}|" < $filein > $fileout
	    fileout=$(basename $fileout)
	    FILELIST="$FILELIST $fileout"
	done
	(cd $WORK_DIR/dist/$warname; zip -u $OUTPUT/$warname.war $FILELIST)
	message "$WORK_DIR/webapps/$warname.war changed"
    fi
done
